/* report.c generated by valac 0.22.1, the Vala compiler
 * generated from report.vala, do not modify */

/*
 * Copyright (C) 2008-2009 Abderrahim Kitouni
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* A Vala.Report subclass for reporting errors in Anjuta UI */

#include <glib.h>
#include <glib-object.h>
#include <vala.h>
#include <libanjuta/interfaces/libanjuta-interfaces.h>
#include <valagee.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define TYPE_ANJUTA_REPORT (anjuta_report_get_type ())
#define ANJUTA_REPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANJUTA_REPORT, AnjutaReport))
#define ANJUTA_REPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANJUTA_REPORT, AnjutaReportClass))
#define IS_ANJUTA_REPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANJUTA_REPORT))
#define IS_ANJUTA_REPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANJUTA_REPORT))
#define ANJUTA_REPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANJUTA_REPORT, AnjutaReportClass))

typedef struct _AnjutaReport AnjutaReport;
typedef struct _AnjutaReportClass AnjutaReportClass;
typedef struct _AnjutaReportPrivate AnjutaReportPrivate;

#define ANJUTA_REPORT_TYPE_ERROR (anjuta_report_error_get_type ())
typedef struct _AnjutaReportError AnjutaReportError;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _anjuta_report_error_free0(var) ((var == NULL) ? NULL : (var = (anjuta_report_error_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _vala_source_reference_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_reference_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _AnjutaReport {
	ValaReport parent_instance;
	AnjutaReportPrivate * priv;
};

struct _AnjutaReportClass {
	ValaReportClass parent_class;
};

struct _AnjutaReportError {
	ValaSourceReference* source;
	gboolean error;
	gchar* message;
};

struct _AnjutaReportPrivate {
	IAnjutaDocumentManager* _docman;
	ValaList* errors_list;
	GStaticRecMutex __lock_errors_list;
	gboolean general_error;
};


static gpointer anjuta_report_parent_class = NULL;
static GType anjuta_report_type_id = 0;

GType anjuta_report_get_type (void) G_GNUC_CONST;
GType anjuta_report_register_type (GTypeModule * module);
static GType anjuta_report_error_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static AnjutaReportError* anjuta_report_error_dup (const AnjutaReportError* self);
static void anjuta_report_error_free (AnjutaReportError* self);
static void anjuta_report_error_copy (const AnjutaReportError* self, AnjutaReportError* dest);
static void anjuta_report_error_destroy (AnjutaReportError* self);
#define ANJUTA_REPORT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ANJUTA_REPORT, AnjutaReportPrivate))
enum  {
	ANJUTA_REPORT_DUMMY_PROPERTY,
	ANJUTA_REPORT_DOCMAN
};
void anjuta_report_update_errors (AnjutaReport* self, IAnjutaEditor* editor);
void anjuta_report_clear_error_indicators (AnjutaReport* self, ValaSourceFile* file);
IAnjutaDocumentManager* anjuta_report_get_docman (AnjutaReport* self);
static void anjuta_report_real_warn (ValaReport* base, ValaSourceReference* source, const gchar* message);
static void anjuta_report_real_err (ValaReport* base, ValaSourceReference* source, const gchar* message);
AnjutaReport* anjuta_report_new (void);
AnjutaReport* anjuta_report_construct (GType object_type);
void anjuta_report_set_docman (AnjutaReport* self, IAnjutaDocumentManager* value);
static void anjuta_report_finalize (GObject* obj);
static void _vala_anjuta_report_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_anjuta_report_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gpointer _vala_iterable_ref0 (gpointer self) {
	return self ? vala_iterable_ref (self) : NULL;
}


void anjuta_report_update_errors (AnjutaReport* self, IAnjutaEditor* editor) {
	IAnjutaIndicable* ind = NULL;
	IAnjutaEditor* _tmp0_ = NULL;
	IAnjutaIndicable* _tmp1_ = NULL;
	IAnjutaMarkable* mark = NULL;
	IAnjutaEditor* _tmp2_ = NULL;
	IAnjutaMarkable* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	IAnjutaIndicable* _tmp5_ = NULL;
	gboolean _tmp7_ = FALSE;
	IAnjutaIndicable* _tmp8_ = NULL;
	IAnjutaMarkable* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (editor != NULL);
	_tmp0_ = editor;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, ianjuta_indicable_get_type ()) ? ((IAnjutaIndicable*) _tmp0_) : NULL);
	ind = _tmp1_;
	_tmp2_ = editor;
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, ianjuta_markable_get_type ()) ? ((IAnjutaMarkable*) _tmp2_) : NULL);
	mark = _tmp3_;
	_tmp5_ = ind;
	if (_tmp5_ == NULL) {
		IAnjutaMarkable* _tmp6_ = NULL;
		_tmp6_ = mark;
		_tmp4_ = _tmp6_ == NULL;
	} else {
		_tmp4_ = FALSE;
	}
	_tmp7_ = _tmp4_;
	if (_tmp7_) {
		_g_object_unref0 (mark);
		_g_object_unref0 (ind);
		return;
	}
	_tmp8_ = ind;
	if (_tmp8_ != NULL) {
		IAnjutaIndicable* _tmp9_ = NULL;
		_tmp9_ = ind;
		ianjuta_indicable_clear (_tmp9_, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (mark);
			_g_object_unref0 (ind);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp10_ = mark;
	if (_tmp10_ != NULL) {
		IAnjutaMarkable* _tmp11_ = NULL;
		_tmp11_ = mark;
		ianjuta_markable_delete_all_markers (_tmp11_, IANJUTA_MARKABLE_MESSAGE, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (mark);
			_g_object_unref0 (ind);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		ValaList* _e_list = NULL;
		ValaList* _tmp12_ = NULL;
		ValaList* _tmp13_ = NULL;
		gint _e_size = 0;
		ValaList* _tmp14_ = NULL;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gint _e_index = 0;
		_tmp12_ = self->priv->errors_list;
		_tmp13_ = _vala_iterable_ref0 (_tmp12_);
		_e_list = _tmp13_;
		_tmp14_ = _e_list;
		_tmp15_ = vala_collection_get_size ((ValaCollection*) _tmp14_);
		_tmp16_ = _tmp15_;
		_e_size = _tmp16_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			gint _tmp19_ = 0;
			AnjutaReportError* e = NULL;
			ValaList* _tmp20_ = NULL;
			gint _tmp21_ = 0;
			gpointer _tmp22_ = NULL;
			const gchar* _tmp23_ = NULL;
			IAnjutaEditor* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
			AnjutaReportError* _tmp26_ = NULL;
			ValaSourceReference* _tmp27_ = NULL;
			ValaSourceFile* _tmp28_ = NULL;
			ValaSourceFile* _tmp29_ = NULL;
			const gchar* _tmp30_ = NULL;
			const gchar* _tmp31_ = NULL;
			gboolean _tmp32_ = FALSE;
			_tmp17_ = _e_index;
			_e_index = _tmp17_ + 1;
			_tmp18_ = _e_index;
			_tmp19_ = _e_size;
			if (!(_tmp18_ < _tmp19_)) {
				break;
			}
			_tmp20_ = _e_list;
			_tmp21_ = _e_index;
			_tmp22_ = vala_list_get (_tmp20_, _tmp21_);
			e = (AnjutaReportError*) _tmp22_;
			_tmp24_ = editor;
			_tmp25_ = ianjuta_document_get_filename (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, ianjuta_document_get_type (), IAnjutaDocument), &_inner_error_);
			_tmp23_ = _tmp25_;
			if (_inner_error_ != NULL) {
				_anjuta_report_error_free0 (e);
				_vala_iterable_unref0 (_e_list);
				_g_object_unref0 (mark);
				_g_object_unref0 (ind);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp26_ = e;
			_tmp27_ = (*_tmp26_).source;
			_tmp28_ = vala_source_reference_get_file (_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = vala_source_file_get_filename (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp32_ = g_str_has_suffix (_tmp31_, _tmp23_);
			if (_tmp32_) {
				IAnjutaIndicable* _tmp33_ = NULL;
				IAnjutaEditor* _tmp75_ = NULL;
				_tmp33_ = ind;
				if (_tmp33_ != NULL) {
					IAnjutaIterable* begin_iter = NULL;
					IAnjutaEditor* _tmp34_ = NULL;
					AnjutaReportError* _tmp35_ = NULL;
					ValaSourceReference* _tmp36_ = NULL;
					ValaSourceLocation _tmp37_ = {0};
					ValaSourceLocation _tmp38_ = {0};
					gint _tmp39_ = 0;
					IAnjutaIterable* _tmp40_ = NULL;
					IAnjutaIterable* end_iter = NULL;
					IAnjutaEditor* _tmp51_ = NULL;
					AnjutaReportError* _tmp52_ = NULL;
					ValaSourceReference* _tmp53_ = NULL;
					ValaSourceLocation _tmp54_ = {0};
					ValaSourceLocation _tmp55_ = {0};
					gint _tmp56_ = 0;
					IAnjutaIterable* _tmp57_ = NULL;
					IAnjutaIndicableIndicator _tmp68_ = 0;
					AnjutaReportError* _tmp69_ = NULL;
					gboolean _tmp70_ = FALSE;
					IAnjutaIndicable* _tmp71_ = NULL;
					IAnjutaIterable* _tmp72_ = NULL;
					IAnjutaIterable* _tmp73_ = NULL;
					IAnjutaIndicableIndicator _tmp74_ = 0;
					_tmp34_ = editor;
					_tmp35_ = e;
					_tmp36_ = (*_tmp35_).source;
					vala_source_reference_get_begin (_tmp36_, &_tmp37_);
					_tmp38_ = _tmp37_;
					_tmp39_ = _tmp38_.line;
					_tmp40_ = ianjuta_editor_get_line_begin_position (_tmp34_, _tmp39_, &_inner_error_);
					begin_iter = _tmp40_;
					if (_inner_error_ != NULL) {
						_anjuta_report_error_free0 (e);
						_vala_iterable_unref0 (_e_list);
						_g_object_unref0 (mark);
						_g_object_unref0 (ind);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					{
						gint i = 0;
						i = 1;
						{
							gboolean _tmp41_ = FALSE;
							_tmp41_ = TRUE;
							while (TRUE) {
								gboolean _tmp42_ = FALSE;
								gint _tmp44_ = 0;
								AnjutaReportError* _tmp45_ = NULL;
								ValaSourceReference* _tmp46_ = NULL;
								ValaSourceLocation _tmp47_ = {0};
								ValaSourceLocation _tmp48_ = {0};
								gint _tmp49_ = 0;
								IAnjutaIterable* _tmp50_ = NULL;
								_tmp42_ = _tmp41_;
								if (!_tmp42_) {
									gint _tmp43_ = 0;
									_tmp43_ = i;
									i = _tmp43_ + 1;
								}
								_tmp41_ = FALSE;
								_tmp44_ = i;
								_tmp45_ = e;
								_tmp46_ = (*_tmp45_).source;
								vala_source_reference_get_begin (_tmp46_, &_tmp47_);
								_tmp48_ = _tmp47_;
								_tmp49_ = _tmp48_.column;
								if (!(_tmp44_ < _tmp49_)) {
									break;
								}
								_tmp50_ = begin_iter;
								ianjuta_iterable_next (_tmp50_, &_inner_error_);
								if (_inner_error_ != NULL) {
									_g_object_unref0 (begin_iter);
									_anjuta_report_error_free0 (e);
									_vala_iterable_unref0 (_e_list);
									_g_object_unref0 (mark);
									_g_object_unref0 (ind);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return;
								}
							}
						}
					}
					_tmp51_ = editor;
					_tmp52_ = e;
					_tmp53_ = (*_tmp52_).source;
					vala_source_reference_get_end (_tmp53_, &_tmp54_);
					_tmp55_ = _tmp54_;
					_tmp56_ = _tmp55_.line;
					_tmp57_ = ianjuta_editor_get_line_begin_position (_tmp51_, _tmp56_, &_inner_error_);
					end_iter = _tmp57_;
					if (_inner_error_ != NULL) {
						_g_object_unref0 (begin_iter);
						_anjuta_report_error_free0 (e);
						_vala_iterable_unref0 (_e_list);
						_g_object_unref0 (mark);
						_g_object_unref0 (ind);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp58_ = FALSE;
							_tmp58_ = TRUE;
							while (TRUE) {
								gboolean _tmp59_ = FALSE;
								gint _tmp61_ = 0;
								AnjutaReportError* _tmp62_ = NULL;
								ValaSourceReference* _tmp63_ = NULL;
								ValaSourceLocation _tmp64_ = {0};
								ValaSourceLocation _tmp65_ = {0};
								gint _tmp66_ = 0;
								IAnjutaIterable* _tmp67_ = NULL;
								_tmp59_ = _tmp58_;
								if (!_tmp59_) {
									gint _tmp60_ = 0;
									_tmp60_ = i;
									i = _tmp60_ + 1;
								}
								_tmp58_ = FALSE;
								_tmp61_ = i;
								_tmp62_ = e;
								_tmp63_ = (*_tmp62_).source;
								vala_source_reference_get_end (_tmp63_, &_tmp64_);
								_tmp65_ = _tmp64_;
								_tmp66_ = _tmp65_.column;
								if (!(_tmp61_ < _tmp66_)) {
									break;
								}
								_tmp67_ = end_iter;
								ianjuta_iterable_next (_tmp67_, &_inner_error_);
								if (_inner_error_ != NULL) {
									_g_object_unref0 (end_iter);
									_g_object_unref0 (begin_iter);
									_anjuta_report_error_free0 (e);
									_vala_iterable_unref0 (_e_list);
									_g_object_unref0 (mark);
									_g_object_unref0 (ind);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
									g_clear_error (&_inner_error_);
									return;
								}
							}
						}
					}
					_tmp69_ = e;
					_tmp70_ = (*_tmp69_).error;
					if (_tmp70_) {
						_tmp68_ = IANJUTA_INDICABLE_CRITICAL;
					} else {
						_tmp68_ = IANJUTA_INDICABLE_WARNING;
					}
					_tmp71_ = ind;
					_tmp72_ = begin_iter;
					_tmp73_ = end_iter;
					_tmp74_ = _tmp68_;
					ianjuta_indicable_set (_tmp71_, _tmp72_, _tmp73_, _tmp74_, &_inner_error_);
					if (_inner_error_ != NULL) {
						_g_object_unref0 (end_iter);
						_g_object_unref0 (begin_iter);
						_anjuta_report_error_free0 (e);
						_vala_iterable_unref0 (_e_list);
						_g_object_unref0 (mark);
						_g_object_unref0 (ind);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
					_g_object_unref0 (end_iter);
					_g_object_unref0 (begin_iter);
				}
				_tmp75_ = editor;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp75_, ianjuta_markable_get_type ())) {
					IAnjutaMarkable* _tmp76_ = NULL;
					AnjutaReportError* _tmp77_ = NULL;
					ValaSourceReference* _tmp78_ = NULL;
					ValaSourceLocation _tmp79_ = {0};
					ValaSourceLocation _tmp80_ = {0};
					gint _tmp81_ = 0;
					AnjutaReportError* _tmp82_ = NULL;
					const gchar* _tmp83_ = NULL;
					_tmp76_ = mark;
					_tmp77_ = e;
					_tmp78_ = (*_tmp77_).source;
					vala_source_reference_get_begin (_tmp78_, &_tmp79_);
					_tmp80_ = _tmp79_;
					_tmp81_ = _tmp80_.line;
					_tmp82_ = e;
					_tmp83_ = (*_tmp82_).message;
					ianjuta_markable_mark (_tmp76_, _tmp81_, IANJUTA_MARKABLE_MESSAGE, _tmp83_, &_inner_error_);
					if (_inner_error_ != NULL) {
						_anjuta_report_error_free0 (e);
						_vala_iterable_unref0 (_e_list);
						_g_object_unref0 (mark);
						_g_object_unref0 (ind);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
			}
			_anjuta_report_error_free0 (e);
		}
		_vala_iterable_unref0 (_e_list);
	}
	_g_object_unref0 (mark);
	_g_object_unref0 (ind);
}


void anjuta_report_clear_error_indicators (AnjutaReport* self, ValaSourceFile* file) {
	ValaSourceFile* _tmp0_ = NULL;
	GList* _tmp35_ = NULL;
	IAnjutaDocumentManager* _tmp36_ = NULL;
	GList* _tmp37_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = file;
	if (_tmp0_ == NULL) {
		GEqualFunc _tmp1_ = NULL;
		ValaArrayList* _tmp2_ = NULL;
		_tmp1_ = g_direct_equal;
		_tmp2_ = vala_array_list_new (ANJUTA_REPORT_TYPE_ERROR, (GBoxedCopyFunc) anjuta_report_error_dup, anjuta_report_error_free, _tmp1_);
		_vala_iterable_unref0 (self->priv->errors_list);
		self->priv->errors_list = (ValaList*) _tmp2_;
		((ValaReport*) self)->errors = 0;
	} else {
		ValaList* _tmp30_ = NULL;
		gint _tmp31_ = 0;
		gint _tmp32_ = 0;
		gint _tmp33_ = 0;
		gint _tmp34_ = 0;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					gboolean _tmp4_ = FALSE;
					gint _tmp6_ = 0;
					ValaList* _tmp7_ = NULL;
					gint _tmp8_ = 0;
					gint _tmp9_ = 0;
					ValaList* _tmp10_ = NULL;
					gint _tmp11_ = 0;
					gpointer _tmp12_ = NULL;
					AnjutaReportError* _tmp13_ = NULL;
					ValaSourceReference* _tmp14_ = NULL;
					ValaSourceFile* _tmp15_ = NULL;
					ValaSourceFile* _tmp16_ = NULL;
					ValaSourceFile* _tmp17_ = NULL;
					gboolean _tmp18_ = FALSE;
					_tmp4_ = _tmp3_;
					if (!_tmp4_) {
						gint _tmp5_ = 0;
						_tmp5_ = i;
						i = _tmp5_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp6_ = i;
					_tmp7_ = self->priv->errors_list;
					_tmp8_ = vala_collection_get_size ((ValaCollection*) _tmp7_);
					_tmp9_ = _tmp8_;
					if (!(_tmp6_ < _tmp9_)) {
						break;
					}
					_tmp10_ = self->priv->errors_list;
					_tmp11_ = i;
					_tmp12_ = vala_list_get (_tmp10_, _tmp11_);
					_tmp13_ = (AnjutaReportError*) _tmp12_;
					_tmp14_ = (*_tmp13_).source;
					_tmp15_ = vala_source_reference_get_file (_tmp14_);
					_tmp16_ = _tmp15_;
					_tmp17_ = file;
					_tmp18_ = _tmp16_ == _tmp17_;
					_anjuta_report_error_free0 (_tmp13_);
					if (_tmp18_) {
						ValaList* _tmp19_ = NULL;
						gint _tmp20_ = 0;
						gpointer _tmp21_ = NULL;
						AnjutaReportError* _tmp22_ = NULL;
						gboolean _tmp23_ = FALSE;
						gboolean _tmp24_ = FALSE;
						ValaList* _tmp27_ = NULL;
						gint _tmp28_ = 0;
						gint _tmp29_ = 0;
						_tmp19_ = self->priv->errors_list;
						_tmp20_ = i;
						_tmp21_ = vala_list_get (_tmp19_, _tmp20_);
						_tmp22_ = (AnjutaReportError*) _tmp21_;
						_tmp23_ = (*_tmp22_).error;
						_tmp24_ = _tmp23_;
						_anjuta_report_error_free0 (_tmp22_);
						if (_tmp24_) {
							gint _tmp25_ = 0;
							_tmp25_ = ((ValaReport*) self)->errors;
							((ValaReport*) self)->errors = _tmp25_ - 1;
						} else {
							gint _tmp26_ = 0;
							_tmp26_ = ((ValaReport*) self)->warnings;
							((ValaReport*) self)->warnings = _tmp26_ - 1;
						}
						_tmp27_ = self->priv->errors_list;
						_tmp28_ = i;
						vala_list_remove_at (_tmp27_, _tmp28_);
						_tmp29_ = i;
						i = _tmp29_ - 1;
					}
				}
			}
		}
		_tmp30_ = self->priv->errors_list;
		_tmp31_ = vala_collection_get_size ((ValaCollection*) _tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = ((ValaReport*) self)->errors;
		_tmp34_ = ((ValaReport*) self)->warnings;
		_vala_assert (_tmp32_ <= (_tmp33_ + _tmp34_), "errors_list.size <= errors + warnings");
	}
	_tmp36_ = self->priv->_docman;
	_tmp37_ = ianjuta_document_manager_get_doc_widgets (_tmp36_, &_inner_error_);
	_tmp35_ = _tmp37_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		GList* doc_collection = NULL;
		GList* doc_it = NULL;
		doc_collection = _tmp35_;
		for (doc_it = doc_collection; doc_it != NULL; doc_it = doc_it->next) {
			GtkWidget* doc = NULL;
			doc = (GtkWidget*) doc_it->data;
			{
				GtkWidget* _tmp38_ = NULL;
				GtkWidget* _tmp40_ = NULL;
				_tmp38_ = doc;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp38_, ianjuta_indicable_get_type ())) {
					GtkWidget* _tmp39_ = NULL;
					_tmp39_ = doc;
					ianjuta_indicable_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, ianjuta_indicable_get_type (), IAnjutaIndicable), &_inner_error_);
					if (_inner_error_ != NULL) {
						_g_list_free0 (doc_collection);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
				_tmp40_ = doc;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp40_, ianjuta_markable_get_type ())) {
					GtkWidget* _tmp41_ = NULL;
					_tmp41_ = doc;
					ianjuta_markable_delete_all_markers (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, ianjuta_markable_get_type (), IAnjutaMarkable), IANJUTA_MARKABLE_MESSAGE, &_inner_error_);
					if (_inner_error_ != NULL) {
						_g_list_free0 (doc_collection);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
			}
		}
		_g_list_free0 (doc_collection);
	}
}


static gpointer _vala_source_reference_ref0 (gpointer self) {
	return self ? vala_source_reference_ref (self) : NULL;
}


static void anjuta_report_real_warn (ValaReport* base, ValaSourceReference* source, const gchar* message) {
	AnjutaReport * self;
	gint _tmp0_ = 0;
	ValaSourceReference* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	self = (AnjutaReport*) base;
	g_return_if_fail (message != NULL);
	_tmp0_ = ((ValaReport*) self)->warnings;
	((ValaReport*) self)->warnings = _tmp0_ + 1;
	_tmp1_ = source;
	if (_tmp1_ == NULL) {
		return;
	}
	{
		ValaList* _tmp2_ = NULL;
		_tmp2_ = self->priv->errors_list;
		g_static_rec_mutex_lock (&self->priv->__lock_errors_list);
		{
			ValaList* _tmp3_ = NULL;
			ValaSourceReference* _tmp4_ = NULL;
			ValaSourceReference* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			AnjutaReportError _tmp8_ = {0};
			AnjutaReportError _tmp9_ = {0};
			AnjutaReportError _tmp10_ = {0};
			_tmp3_ = self->priv->errors_list;
			_tmp4_ = source;
			_tmp5_ = _vala_source_reference_ref0 (_tmp4_);
			_tmp6_ = message;
			_tmp7_ = g_strdup (_tmp6_);
			memset (&_tmp8_, 0, sizeof (AnjutaReportError));
			_vala_source_reference_unref0 (_tmp8_.source);
			_tmp8_.source = _tmp5_;
			_g_free0 (_tmp8_.message);
			_tmp8_.message = _tmp7_;
			_tmp8_.error = FALSE;
			_tmp9_ = _tmp8_;
			_tmp10_ = _tmp9_;
			vala_collection_add ((ValaCollection*) _tmp3_, &_tmp10_);
			anjuta_report_error_destroy (&_tmp9_);
		}
		__finally11:
		{
			ValaList* _tmp11_ = NULL;
			_tmp11_ = self->priv->errors_list;
			g_static_rec_mutex_unlock (&self->priv->__lock_errors_list);
		}
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void anjuta_report_real_err (ValaReport* base, ValaSourceReference* source, const gchar* message) {
	AnjutaReport * self;
	gint _tmp0_ = 0;
	ValaSourceReference* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	self = (AnjutaReport*) base;
	g_return_if_fail (message != NULL);
	_tmp0_ = ((ValaReport*) self)->errors;
	((ValaReport*) self)->errors = _tmp0_ + 1;
	_tmp1_ = source;
	if (_tmp1_ == NULL) {
		self->priv->general_error = TRUE;
		return;
	}
	{
		ValaList* _tmp2_ = NULL;
		_tmp2_ = self->priv->errors_list;
		g_static_rec_mutex_lock (&self->priv->__lock_errors_list);
		{
			ValaList* _tmp3_ = NULL;
			ValaSourceReference* _tmp4_ = NULL;
			ValaSourceReference* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			AnjutaReportError _tmp8_ = {0};
			AnjutaReportError _tmp9_ = {0};
			AnjutaReportError _tmp10_ = {0};
			_tmp3_ = self->priv->errors_list;
			_tmp4_ = source;
			_tmp5_ = _vala_source_reference_ref0 (_tmp4_);
			_tmp6_ = message;
			_tmp7_ = g_strdup (_tmp6_);
			memset (&_tmp8_, 0, sizeof (AnjutaReportError));
			_vala_source_reference_unref0 (_tmp8_.source);
			_tmp8_.source = _tmp5_;
			_g_free0 (_tmp8_.message);
			_tmp8_.message = _tmp7_;
			_tmp8_.error = TRUE;
			_tmp9_ = _tmp8_;
			_tmp10_ = _tmp9_;
			vala_collection_add ((ValaCollection*) _tmp3_, &_tmp10_);
			anjuta_report_error_destroy (&_tmp9_);
		}
		__finally12:
		{
			ValaList* _tmp11_ = NULL;
			_tmp11_ = self->priv->errors_list;
			g_static_rec_mutex_unlock (&self->priv->__lock_errors_list);
		}
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


AnjutaReport* anjuta_report_construct (GType object_type) {
	AnjutaReport * self = NULL;
	self = (AnjutaReport*) vala_report_construct (object_type);
	return self;
}


AnjutaReport* anjuta_report_new (void) {
	return anjuta_report_construct (TYPE_ANJUTA_REPORT);
}


IAnjutaDocumentManager* anjuta_report_get_docman (AnjutaReport* self) {
	IAnjutaDocumentManager* result;
	IAnjutaDocumentManager* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_docman;
	result = _tmp0_;
	return result;
}


void anjuta_report_set_docman (AnjutaReport* self, IAnjutaDocumentManager* value) {
	IAnjutaDocumentManager* _tmp0_ = NULL;
	IAnjutaDocumentManager* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_docman);
	self->priv->_docman = _tmp1_;
	g_object_notify ((GObject *) self, "docman");
}


static void anjuta_report_error_copy (const AnjutaReportError* self, AnjutaReportError* dest) {
	ValaSourceReference* _tmp0_ = NULL;
	ValaSourceReference* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	_tmp0_ = (*self).source;
	_tmp1_ = _vala_source_reference_ref0 (_tmp0_);
	_vala_source_reference_unref0 ((*dest).source);
	(*dest).source = _tmp1_;
	_tmp2_ = (*self).error;
	(*dest).error = _tmp2_;
	_tmp3_ = (*self).message;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 ((*dest).message);
	(*dest).message = _tmp4_;
}


static void anjuta_report_error_destroy (AnjutaReportError* self) {
	_vala_source_reference_unref0 ((*self).source);
	_g_free0 ((*self).message);
}


static AnjutaReportError* anjuta_report_error_dup (const AnjutaReportError* self) {
	AnjutaReportError* dup;
	dup = g_new0 (AnjutaReportError, 1);
	anjuta_report_error_copy (self, dup);
	return dup;
}


static void anjuta_report_error_free (AnjutaReportError* self) {
	anjuta_report_error_destroy (self);
	g_free (self);
}


static GType anjuta_report_error_get_type (void) {
	static volatile gsize anjuta_report_error_type_id__volatile = 0;
	if (g_once_init_enter (&anjuta_report_error_type_id__volatile)) {
		GType anjuta_report_error_type_id;
		anjuta_report_error_type_id = g_boxed_type_register_static ("AnjutaReportError", (GBoxedCopyFunc) anjuta_report_error_dup, (GBoxedFreeFunc) anjuta_report_error_free);
		g_once_init_leave (&anjuta_report_error_type_id__volatile, anjuta_report_error_type_id);
	}
	return anjuta_report_error_type_id__volatile;
}


static void anjuta_report_class_init (AnjutaReportClass * klass) {
	anjuta_report_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AnjutaReportPrivate));
	VALA_REPORT_CLASS (klass)->warn = anjuta_report_real_warn;
	VALA_REPORT_CLASS (klass)->err = anjuta_report_real_err;
	G_OBJECT_CLASS (klass)->get_property = _vala_anjuta_report_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_anjuta_report_set_property;
	G_OBJECT_CLASS (klass)->finalize = anjuta_report_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ANJUTA_REPORT_DOCMAN, g_param_spec_object ("docman", "docman", "docman", ianjuta_document_manager_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void anjuta_report_instance_init (AnjutaReport * self) {
	GEqualFunc _tmp0_ = NULL;
	ValaArrayList* _tmp1_ = NULL;
	self->priv = ANJUTA_REPORT_GET_PRIVATE (self);
	g_static_rec_mutex_init (&self->priv->__lock_errors_list);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (ANJUTA_REPORT_TYPE_ERROR, (GBoxedCopyFunc) anjuta_report_error_dup, anjuta_report_error_free, _tmp0_);
	self->priv->errors_list = (ValaList*) _tmp1_;
	self->priv->general_error = FALSE;
}


static void anjuta_report_finalize (GObject* obj) {
	AnjutaReport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ANJUTA_REPORT, AnjutaReport);
	_g_object_unref0 (self->priv->_docman);
	g_static_rec_mutex_free (&self->priv->__lock_errors_list);
	_vala_iterable_unref0 (self->priv->errors_list);
	G_OBJECT_CLASS (anjuta_report_parent_class)->finalize (obj);
}


GType anjuta_report_get_type (void) {
	return anjuta_report_type_id;
}


GType anjuta_report_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (AnjutaReportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) anjuta_report_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AnjutaReport), 0, (GInstanceInitFunc) anjuta_report_instance_init, NULL };
	anjuta_report_type_id = g_type_module_register_type (module, VALA_TYPE_REPORT, "AnjutaReport", &g_define_type_info, 0);
	return anjuta_report_type_id;
}


static void _vala_anjuta_report_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AnjutaReport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ANJUTA_REPORT, AnjutaReport);
	switch (property_id) {
		case ANJUTA_REPORT_DOCMAN:
		g_value_set_object (value, anjuta_report_get_docman (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_anjuta_report_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	AnjutaReport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ANJUTA_REPORT, AnjutaReport);
	switch (property_id) {
		case ANJUTA_REPORT_DOCMAN:
		anjuta_report_set_docman (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



